if exists (select 1
            from  sysobjects
           where  id = object_id('sys_user')
            and   type = 'U')
   drop table sys_user
go

/*==============================================================*/
/* Table: sys_user                                              */
/*==============================================================*/
create table sys_user (
   KeyID                uniqueidentifier     not null,
   UserID               nvarchar(20)         null,
   UserName             nvarchar(30)         null,
   Password             nvarchar(20)         null,
   OrgID                nvarchar(40)         null,
   OrgName              nvarchar(50)         null,
   IsActive             nchar(1)             null,
   IsCanLogin           nchar(1)             null,
   EmailAddress         nvarchar(50)         null,
   Job                  nvarchar(50)         null,
   constraint PK_SYS_USER primary key nonclustered (KeyID),
   constraint AK_UNIQUE_SYS_USER unique (UserID)
)
go

if exists (select 1
            from  sysobjects
           where  id = object_id('sys_permission')
            and   type = 'U')
   drop table sys_permission
go

/*==============================================================*/
/* Table: sys_permission                                        */
/*==============================================================*/
create table sys_permission (
   KeyID                uniqueidentifier     not null,
   PermissionID         nvarchar(50)         null,
   PermissionName       nvarchar(50)         null,
   ParentID             nvarchar(20)         null,
   PermissonType        int                  null,
   Remark               nvarchar(100)        null,
   ModuleFormClass      nvarchar(100)        null,
   Sort                 int                  null,
   IsSingleFrom         nchar(1)             null,
   constraint PK_SYS_PERMISSION primary key nonclustered (KeyID),
   constraint AK_UNIQUE_SYS_PERM unique (PermissionID)
)
go

if exists (select 1
            from  sysobjects
           where  id = object_id('sys_role_user')
            and   type = 'U')
   drop table sys_role_user
go

/*==============================================================*/
/* Table: sys_role_user                                         */
/*==============================================================*/
create table sys_role_user (
   KeyID                uniqueidentifier     not null,
   UserID               nvarchar(20)         not null,
   UserName             nvarchar(30)         null,
   RoleID               nvarchar(20)         not null,
   RoleName             nvarchar(50)         null,
   constraint PK_SYS_ROLE_USER primary key (KeyID)
)
go