﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Configuration;
using System.Data.SqlClient;
using System.Data.Common;
using System.Xml;

namespace MappingCode
{
    /// <summary>
    /// Interaction logic for DbConfig.xaml
    /// </summary>
    public partial class DbConfig : Page
    {
        public string Server { get; set; }
        public string UserID { get; set; }
        public string Database { get; set; }
        public string Password { get; set; }
        public string ConnectString { get; set; }

        public DbConfig()
        {
            InitializeComponent();
        }

        private void btnConnTest_Click(object sender, RoutedEventArgs e)
        {
            ConnTest();
        }


        private void btnOk_Click(object sender, RoutedEventArgs e)
        {
            this.NavigationService.Navigate(new MappingPrepare());
        }

        private void GetUI()
        {
            this.Server = this.textBox1.Text;
            this.Database = textBox2.Text;
            this.UserID = textBox3.Text;
            this.Password = textBox4.Text;
            //string cs = "Provider=SQLOLEDB.1;User ID=sa;Password=;Initial Catalog=FreightNet;Data Source=192.168.1.100;";
            if (string.IsNullOrEmpty(this.UserID))
            {
                this.ConnectString = string.Format("Integrated Security=SSPI;Initial Catalog = {0};Data Source={1}",
                    this.Database, this.Server
                    );
            }
            else
            {
                this.ConnectString = string.Format("Initial Catalog={0};Data Source={1};User ID={2};Password={3}",
                    this.Database, this.Server, this.UserID, this.Password
                    );
            }
        }

        private void ConnTest()
        {
            GetUI();
            string pn = ConfigurationManager.ConnectionStrings[0].ProviderName;
            if (string.IsNullOrEmpty(pn))
            {
                pn = "System.Data.SqlClient";
            }
            DbProviderFactory dbfactory = DbProviderFactories.GetFactory(pn);
            var conn = dbfactory.CreateConnection();
            conn.ConnectionString = this.ConnectString;
            try
            {
                conn.Open();
                //if (conn.State == System.Data.ConnectionState.Open)
                //{

                //}
                MessageBox.Show("连接成功");
                //ConfigurationManager.ConnectionStrings[0].ConnectionString = this.ConnectString;
                Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
                config.AppSettings.Settings["conn"].Value = this.ConnectString;
                config.Save(ConfigurationSaveMode.Modified);

            }
            catch (Exception ex)
            {
                MessageBox.Show("连接失败:" + ex.Message);
            }
        }

        private void SaveConfig()
        {

        }
    }
}
