﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf.Xaml;
using Wcdf.BaseData.Model;
using System.Windows;
using Wcdf.ToolClass;

namespace Wcdf.BaseData.Client.ViewModel
{
    public class BsMeterialCatalogListVM:ViewModel<Wcdf.BaseData.Model.BsCatalogList>
    {
        public BsMeterialCatalogListVM()
        {
            if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(this))
            {
                this.ManageObjectLifetime = true;
                DoRefresh(() => Wcdf.DataPortal.Fetch<BsCatalogList>());
                //var top = new EntityTree<BsCatalogList, BsCatalog>();
                //top.Node = new BsCatalog();
                //top.Node.CatalogName = "商品目录";
                var tm = new EntityTree<BsCatalogList, BsCatalog>(this.Model, new BsCatalog(), "KeyID", "ParentKeyID");
                //if(tm.Node!=null)
                //    top.AddNewItem(tm);
                tm.Node = new BsCatalog();
                tm.Node.CatalogName = "商品目录";
                this.TreeModel = new EntityTree<BsCatalogList, BsCatalog>();
                //this.TreeModel = tm;
                this.TreeModel.AddNewItem(tm);
                //this.ManageObjectLifetime = true;
                //this.TreeMode = new EntityTree<MmsCatalogList, MmCatalog>(this.Model, new MmCatalog(), "KeyID", "ParentKeyID");
            }
        }

        public void AddChild(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            var parent = e.MethodParameter as EntityTree<BsCatalogList, BsCatalog>;
            string classcd,parentcd;
            if (string.IsNullOrEmpty(parent.Node.ClassCD))
            {
                //var child = this.Model.AddNew();
                classcd = this.CreateChildOrgID(this.TreeModel.ChildNodes[0]);
                parentcd =string.Empty;
                //add top
            }
            else
            {
                classcd = this.CreateChildOrgID(parent);
                parentcd = parent.Node.KeyID.ToString();
            }
            this.SelectedCatalog = this.Model.AddNew();
            this.SelectedCatalog.ClassCD = classcd;
            this.SelectedCatalog.KeyID = Guid.NewGuid();
            this.SelectedCatalog.ParentKeyID = parentcd;
            var item = new EntityTree<BsCatalogList, BsCatalog>();
            item.Parent = parent;
            item.Node = this.SelectedCatalog;
            parent.AddNewItem(item);
        }

        public void ShowCatalog(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            var catalog = (e.MethodParameter as EntityTree<BsCatalogList, BsCatalog>).Node;
            if(!string.IsNullOrEmpty(catalog.ClassCD))
                this.SelectedCatalog = catalog;
        }

        /// <summary>
        /// 创建子级最大ID
        /// </summary>
        /// <param name="parent"></param>
        /// <returns></returns>
        private string CreateChildOrgID(EntityTree<BsCatalogList, BsCatalog> parent)
        {
            //int result = 0;
            if (parent.ChildNodes == null || parent.ChildNodes.Count == 0)
                return parent.Node.ClassCD + "01";
            var query = from nodes in parent.ChildNodes
                        select nodes.Node.ClassCD;
            var max = query.Max();
            string maxID = (int.Parse(max.Substring(max.Length - 2)) + 1).ToString();
            maxID = maxID.PadLeft(2, '0');
            return parent.Node.ClassCD + maxID;
        }


        #region UI
        public static readonly DependencyProperty TreeModelProperty =
        DependencyProperty.Register("TreeMode", typeof(EntityTree<BsCatalogList, BsCatalog>), typeof(BsMeterialCatalogListVM), new PropertyMetadata(null));
        /// <summary>
        /// 
        /// </summary>
        public EntityTree<BsCatalogList, BsCatalog> TreeModel
        {
            get { return (EntityTree<BsCatalogList, BsCatalog>)GetValue(TreeModelProperty); }
            set { SetValue(TreeModelProperty, value); }
        }

        public static readonly DependencyProperty SelectedCatalogProperty =
        DependencyProperty.Register("SelectedCatalog", typeof(BsCatalog), typeof(BsMeterialCatalogListVM), new PropertyMetadata(null));
        /// <summary>
        /// 
        /// </summary>
        public BsCatalog SelectedCatalog
        {
            get { return (BsCatalog)GetValue(SelectedCatalogProperty); }
            set { SetValue(SelectedCatalogProperty, value); }
        }
        #endregion
    }
}
