﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf.Xaml;
using Wcdf.BaseData.Model;
using System.Windows;

namespace Wcdf.BaseData.Client.ViewModel
{
    public class BsUnitListVM:ViewModel<BsUnitList>
    {
        public BsUnitListVM()
        {
            if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(this))
            {
                this.DoRefresh(() => Wcdf.DataPortal.Fetch<BsUnitList>());
            }
            this.UnitTypeItems = new Dictionary<string, string>();
            UnitTypeItems.Add("Q", "数量");
            UnitTypeItems.Add("V", "体积");
            UnitTypeItems.Add("W", "重量");
            UnitTypeItems.Add("A", "面积");
            UnitTypeItems.Add("L", "长度");                    
        }

        #region UI
        public static readonly DependencyProperty SelectedDataProperty =
        DependencyProperty.Register("SelectedData", typeof(BsUnit), typeof(BsUnitListVM), new PropertyMetadata(null));
        /// <summary>
        /// 
        /// </summary>
        public BsUnit SelectedData
        {
            get { return (BsUnit)GetValue(SelectedDataProperty); }
            set { SetValue(SelectedDataProperty, value); }
        }

        public static readonly DependencyProperty UnitTypeItemsProperty =
        DependencyProperty.Register("UnitTypeItems", typeof(Dictionary<string,string>), typeof(BsUnitListVM), new PropertyMetadata(null));
        /// <summary>
        /// 
        /// </summary>
        public Dictionary<string,string> UnitTypeItems
        {
            get { return (Dictionary<string,string>)GetValue(UnitTypeItemsProperty); }
            set { SetValue(UnitTypeItemsProperty, value); }
        }
        #endregion
    }
}
