﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf;
//using System.ComponentModel.DataAnnotations;

namespace Wcdf.BaseData.Model
{
    [Serializable]
    public class BsCatalog : BusinessBase<BsCatalog>
    {
        #region MapperName
        public override string GetDataObjectName()
        {
            return "bs_catalog";
        }
        #endregion

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
            BusinessRules.AddRule(new Wcdf.Rules.CommonRules.Required(CatalogNameProperty, "目录名必输"));
            BusinessRules.AddRule(new Wcdf.Rules.CommonRules.Required(ClassCDProperty, "该值不能为空"));
        }

        #region Data Feild Property

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID",RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> ClassCDProperty = RegisterProperty<string>(c => c.ClassCD, "ClassCD");
        public string ClassCD
        {
            get { return GetProperty(ClassCDProperty); }
            set { SetProperty(ClassCDProperty, value); }
        }

        public static readonly PropertyInfo<string> CatalogNameProperty = RegisterProperty<string>(c => c.CatalogName, "CatalogName");
        public string CatalogName
        {
            get { return GetProperty(CatalogNameProperty); }
            set { SetProperty(CatalogNameProperty, value); }
        }

        public static readonly PropertyInfo<string> ParentKeyIDProperty = RegisterProperty<string>(c => c.ParentKeyID, "ParentKeyID");
        public string ParentKeyID
        {
            get { return GetProperty(ParentKeyIDProperty); }
            set { SetProperty(ParentKeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> RemarksProperty = RegisterProperty<string>(c => c.Remarks, "Remarks");
        public string Remarks
        {
            get { return GetProperty(RemarksProperty); }
            set { SetProperty(RemarksProperty, value); }
        }

        #endregion
    }

    [Serializable]
    public class BsCatalogList : BusinessListBase<BsCatalogList, BsCatalog>
    {
        public BsCatalogList()
        {
        }
    }

}
