﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf;
using System.ComponentModel.DataAnnotations;

namespace Wcdf.BaseData.Model
{
    [Serializable]
    public class BsLocation : BusinessBase<BsLocation>
    {
        #region MapperName
        public override string GetDataObjectName()
        {
            return "bs_location";
        }
        #endregion

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
        }

        #region Data Feild Property

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID",RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> ClassCDProperty = RegisterProperty<string>(c => c.ClassCD, "ClassCD");
        public string ClassCD
        {
            get { return GetProperty(ClassCDProperty); }
            set { SetProperty(ClassCDProperty, value); }
        }

        public static readonly PropertyInfo<string> ParentCDProperty = RegisterProperty<string>(c => c.ParentCD, "ParentCD");
        public string ParentCD
        {
            get { return GetProperty(ParentCDProperty); }
            set { SetProperty(ParentCDProperty, value); }
        }

        public static readonly PropertyInfo<string> LocationNameProperty = RegisterProperty<string>(c => c.LocationName, "LocationName");
        public string LocationName
        {
            get { return GetProperty(LocationNameProperty); }
            set { SetProperty(LocationNameProperty, value); }
        }

        public static readonly PropertyInfo<string> LocationNOProperty = RegisterProperty<string>(c => c.LocationNO, "LocationNO");
        public string LocationNO
        {
            get { return GetProperty(LocationNOProperty); }
            set { SetProperty(LocationNOProperty, value); }
        }

        public static readonly PropertyInfo<string> LabelCodeProperty = RegisterProperty<string>(c => c.LabelCode, "LabelCode");
        public string LabelCode
        {
            get { return GetProperty(LabelCodeProperty); }
            set { SetProperty(LabelCodeProperty, value); }
        }

        public static readonly PropertyInfo<string> LocationKindCDProperty = RegisterProperty<string>(c => c.LocationKindCD, "LocationKindCD");
        public string LocationKindCD
        {
            get { return GetProperty(LocationKindCDProperty); }
            set { SetProperty(LocationKindCDProperty, value); }
        }

        public static readonly PropertyInfo<string> ManagerUserIDProperty = RegisterProperty<string>(c => c.ManagerUserID, "ManagerUserID");
        public string ManagerUserID
        {
            get { return GetProperty(ManagerUserIDProperty); }
            set { SetProperty(ManagerUserIDProperty, value); }
        }

        public static readonly PropertyInfo<decimal> MaxVolumnProperty = RegisterProperty<decimal>(c => c.MaxVolumn, "MaxVolumn");
        public decimal MaxVolumn
        {
            get { return GetProperty(MaxVolumnProperty); }
            set { SetProperty(MaxVolumnProperty, value); }
        }

        public static readonly PropertyInfo<string> VolumnUnitProperty = RegisterProperty<string>(c => c.VolumnUnit, "VolumnUnit");
        public string VolumnUnit
        {
            get { return GetProperty(VolumnUnitProperty); }
            set { SetProperty(VolumnUnitProperty, value); }
        }

        public static readonly PropertyInfo<decimal> MaxWeightProperty = RegisterProperty<decimal>(c => c.MaxWeight, "MaxWeight");
        public decimal MaxWeight
        {
            get { return GetProperty(MaxWeightProperty); }
            set { SetProperty(MaxWeightProperty, value); }
        }

        public static readonly PropertyInfo<string> WeightUnitProperty = RegisterProperty<string>(c => c.WeightUnit, "WeightUnit");
        public string WeightUnit
        {
            get { return GetProperty(WeightUnitProperty); }
            set { SetProperty(WeightUnitProperty, value); }
        }

        public static readonly PropertyInfo<decimal> MaxAreaProperty = RegisterProperty<decimal>(c => c.MaxArea, "MaxArea");
        public decimal MaxArea
        {
            get { return GetProperty(MaxAreaProperty); }
            set { SetProperty(MaxAreaProperty, value); }
        }

        public static readonly PropertyInfo<string> AreaUnitProperty = RegisterProperty<string>(c => c.AreaUnit, "AreaUnit");
        public string AreaUnit
        {
            get { return GetProperty(AreaUnitProperty); }
            set { SetProperty(AreaUnitProperty, value); }
        }

        public static readonly PropertyInfo<decimal> MaxPalletsProperty = RegisterProperty<decimal>(c => c.MaxPallets, "MaxPallets");
        public decimal MaxPallets
        {
            get { return GetProperty(MaxPalletsProperty); }
            set { SetProperty(MaxPalletsProperty, value); }
        }

        public static readonly PropertyInfo<string> StatusProperty = RegisterProperty<string>(c => c.Status, "Status");
        public string Status
        {
            get { return GetProperty(StatusProperty); }
            set { SetProperty(StatusProperty, value); }
        }

        public static readonly PropertyInfo<string> AddressProperty = RegisterProperty<string>(c => c.Address, "Address");
        public string Address
        {
            get { return GetProperty(AddressProperty); }
            set { SetProperty(AddressProperty, value); }
        }

        public static readonly PropertyInfo<string> DescriptionProperty = RegisterProperty<string>(c => c.Description, "Description");
        public string Description
        {
            get { return GetProperty(DescriptionProperty); }
            set { SetProperty(DescriptionProperty, value); }
        }

        public static readonly PropertyInfo<string> LocationFuncCDProperty = RegisterProperty<string>(c => c.LocationFuncCD, "LocationFuncCD");
        public string LocationFuncCD
        {
            get { return GetProperty(LocationFuncCDProperty); }
            set { SetProperty(LocationFuncCDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgCDProperty = RegisterProperty<string>(c => c.OrgCD, "OrgCD");
        public string OrgCD
        {
            get { return GetProperty(OrgCDProperty); }
            set { SetProperty(OrgCDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgNameProperty = RegisterProperty<string>(c => c.OrgName, "OrgName");
        public string OrgName
        {
            get { return GetProperty(OrgNameProperty); }
            set { SetProperty(OrgNameProperty, value); }
        }

        public static readonly PropertyInfo<string> CreatebyIDProperty = RegisterProperty<string>(c => c.CreatebyID, "CreatebyID");
        public string CreatebyID
        {
            get { return GetProperty(CreatebyIDProperty); }
            set { SetProperty(CreatebyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> CreatebyNameProperty = RegisterProperty<string>(c => c.CreatebyName, "CreatebyName");
        public string CreatebyName
        {
            get { return GetProperty(CreatebyNameProperty); }
            set { SetProperty(CreatebyNameProperty, value); }
        }

        public static readonly PropertyInfo<string> CreatebyOrgCDProperty = RegisterProperty<string>(c => c.CreatebyOrgCD, "CreatebyOrgCD");
        public string CreatebyOrgCD
        {
            get { return GetProperty(CreatebyOrgCDProperty); }
            set { SetProperty(CreatebyOrgCDProperty, value); }
        }

        public static readonly PropertyInfo<string> CreatebyOrgNameProperty = RegisterProperty<string>(c => c.CreatebyOrgName, "CreatebyOrgName");
        public string CreatebyOrgName
        {
            get { return GetProperty(CreatebyOrgNameProperty); }
            set { SetProperty(CreatebyOrgNameProperty, value); }
        }

        public static readonly PropertyInfo<DateTime> CreateDateProperty = RegisterProperty<DateTime>(c => c.CreateDate, "CreateDate");
        public DateTime CreateDate
        {
            get { return GetProperty(CreateDateProperty); }
            set { SetProperty(CreateDateProperty, value); }
        }

        public static readonly PropertyInfo<string> TurnOverRatioCDProperty = RegisterProperty<string>(c => c.TurnOverRatioCD, "TurnOverRatioCD");
        public string TurnOverRatioCD
        {
            get { return GetProperty(TurnOverRatioCDProperty); }
            set { SetProperty(TurnOverRatioCDProperty, value); }
        }

        public static readonly PropertyInfo<int> RowZBProperty = RegisterProperty<int>(c => c.RowZB, "RowZB");
        public int RowZB
        {
            get { return GetProperty(RowZBProperty); }
            set { SetProperty(RowZBProperty, value); }
        }

        public static readonly PropertyInfo<int> ColZBProperty = RegisterProperty<int>(c => c.ColZB, "ColZB");
        public int ColZB
        {
            get { return GetProperty(ColZBProperty); }
            set { SetProperty(ColZBProperty, value); }
        }

        public static readonly PropertyInfo<int> LevelZBProperty = RegisterProperty<int>(c => c.LevelZB, "LevelZB");
        public int LevelZB
        {
            get { return GetProperty(LevelZBProperty); }
            set { SetProperty(LevelZBProperty, value); }
        }

        #endregion
    }

    [Serializable]
    public class BsLocationList : BusinessListBase<BsLocationList, BsLocation>
    {
        public BsLocationList()
        {
        }
    }

}
