﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf;
using System.ComponentModel.DataAnnotations;

namespace Wcdf.BaseData.Model
{

    [Serializable]
    public class BsMaterial : BusinessBase<BsMaterial>
    {
        #region MapperName
        public override string GetDataObjectName()
        {
            return "bs_material";
        }
        #endregion

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
            BusinessRules.AddRule(new Wcdf.Rules.CommonRules.Required(MaterialNameProperty, "商品名必输!"));
            BusinessRules.AddRule(new Wcdf.Rules.CommonRules.Required(CatalogIDProperty, "请指定商品分类!"));
            BusinessRules.AddRule(new Wcdf.Rules.CommonRules.Required(QuantityUnitProperty));
        }

        #region Data Feild Property

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID", RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> MaterialNoProperty = RegisterProperty<string>(c => c.MaterialNo, "MaterialNo");
        public string MaterialNo
        {
            get { return GetProperty(MaterialNoProperty); }
            set { SetProperty(MaterialNoProperty, value); }
        }

        public static readonly PropertyInfo<string> MaterialNameProperty = RegisterProperty<string>(c => c.MaterialName, "MaterialName");
        //[Required(AllowEmptyStrings = false, ErrorMessage = "商品名必输!")]
        public string MaterialName
        {
            get { return GetProperty(MaterialNameProperty); }
            set { SetProperty(MaterialNameProperty, value); }
        }

        public static readonly PropertyInfo<string> MaterialAttributeCDProperty = RegisterProperty<string>(c => c.MaterialAttributeCD, "MaterialAttributeCD");
        public string MaterialAttributeCD
        {
            get { return GetProperty(MaterialAttributeCDProperty); }
            set { SetProperty(MaterialAttributeCDProperty, value); }
        }

        public static readonly PropertyInfo<string> CatalogIDProperty = RegisterProperty<string>(c => c.CatalogID, "CatalogID");
        //[Required(AllowEmptyStrings = false, ErrorMessage = "请指定商品分类")]
        public string CatalogID
        {
            get { return GetProperty(CatalogIDProperty); }
            set { SetProperty(CatalogIDProperty, value); }
        }

        public static readonly PropertyInfo<string> SpecProperty = RegisterProperty<string>(c => c.Spec, "Spec");
        public string Spec
        {
            get { return GetProperty(SpecProperty); }
            set { SetProperty(SpecProperty, value); }
        }

        public static readonly PropertyInfo<string> ModelProperty = RegisterProperty<string>(c => c.Model, "Model");
        public string Model
        {
            get { return GetProperty(ModelProperty); }
            set { SetProperty(ModelProperty, value); }
        }

        public static readonly PropertyInfo<string> ColorProperty = RegisterProperty<string>(c => c.Color, "Color");
        public string Color
        {
            get { return GetProperty(ColorProperty); }
            set { SetProperty(ColorProperty, value); }
        }

        public static readonly PropertyInfo<string> ProductionPlaceProperty = RegisterProperty<string>(c => c.ProductionPlace, "ProductionPlace");
        public string ProductionPlace
        {
            get { return GetProperty(ProductionPlaceProperty); }
            set { SetProperty(ProductionPlaceProperty, value); }
        }

        public static readonly PropertyInfo<string> OriMeterialProperty = RegisterProperty<string>(c => c.OriMeterial, "OriMeterial");
        public string OriMeterial
        {
            get { return GetProperty(OriMeterialProperty); }
            set { SetProperty(OriMeterialProperty, value); }
        }

        public static readonly PropertyInfo<decimal> ShelfLifeProperty = RegisterProperty<decimal>(c => c.ShelfLife, "ShelfLife");
        public decimal ShelfLife
        {
            get { return GetProperty(ShelfLifeProperty); }
            set { SetProperty(ShelfLifeProperty, value); }
        }

        public static readonly PropertyInfo<string> QuantityUnitProperty = RegisterProperty<string>(c => c.QuantityUnit, "QuantityUnit");
        public string QuantityUnit
        {
            get { return GetProperty(QuantityUnitProperty); }
            set { SetProperty(QuantityUnitProperty, value); }
        }

        public static readonly PropertyInfo<string> INVUnitProperty = RegisterProperty<string>(c => c.INVUnit, "INVUnit");
        public string INVUnit
        {
            get { return GetProperty(INVUnitProperty); }
            set { SetProperty(INVUnitProperty, value); }
        }

        public static readonly PropertyInfo<string> StatusProperty = RegisterProperty<string>(c => c.Status, "Status");
        public string Status
        {
            get { return GetProperty(StatusProperty); }
            set { SetProperty(StatusProperty, value); }
        }

        public static readonly PropertyInfo<string> DescriptionProperty = RegisterProperty<string>(c => c.Description, "Description");
        public string Description
        {
            get { return GetProperty(DescriptionProperty); }
            set { SetProperty(DescriptionProperty, value); }
        }

        public static readonly PropertyInfo<decimal> PriceProperty = RegisterProperty<decimal>(c => c.Price, "Price");
        public decimal Price
        {
            get { return GetProperty(PriceProperty); }
            set { SetProperty(PriceProperty, value); }
        }

        public static readonly PropertyInfo<decimal> CostProperty = RegisterProperty<decimal>(c => c.Cost, "Cost");
        public decimal Cost
        {
            get { return GetProperty(CostProperty); }
            set { SetProperty(CostProperty, value); }
        }

        public static readonly PropertyInfo<string> CurrCDProperty = RegisterProperty<string>(c => c.CurrCD, "CurrCD");
        public string CurrCD
        {
            get { return GetProperty(CurrCDProperty); }
            set { SetProperty(CurrCDProperty, value); }
        }

        public static readonly PropertyInfo<decimal> TaxRateProperty = RegisterProperty<decimal>(c => c.TaxRate, "TaxRate");
        public decimal TaxRate
        {
            get { return GetProperty(TaxRateProperty); }
            set { SetProperty(TaxRateProperty, value); }
        }

        public static readonly PropertyInfo<string> TaxCategoryProperty = RegisterProperty<string>(c => c.TaxCategory, "TaxCategory");
        public string TaxCategory
        {
            get { return GetProperty(TaxCategoryProperty); }
            set { SetProperty(TaxCategoryProperty, value); }
        }

        public static readonly PropertyInfo<string> CreatebyIDProperty = RegisterProperty<string>(c => c.CreatebyID, "CreatebyID");
        public string CreatebyID
        {
            get { return GetProperty(CreatebyIDProperty); }
            set { SetProperty(CreatebyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> CreatebyNameProperty = RegisterProperty<string>(c => c.CreatebyName, "CreatebyName");
        public string CreatebyName
        {
            get { return GetProperty(CreatebyNameProperty); }
            set { SetProperty(CreatebyNameProperty, value); }
        }

        public static readonly PropertyInfo<string> CreatebyOrgCDProperty = RegisterProperty<string>(c => c.CreatebyOrgCD, "CreatebyOrgCD");
        public string CreatebyOrgCD
        {
            get { return GetProperty(CreatebyOrgCDProperty); }
            set { SetProperty(CreatebyOrgCDProperty, value); }
        }

        public static readonly PropertyInfo<string> CreatebyOrgNameProperty = RegisterProperty<string>(c => c.CreatebyOrgName, "CreatebyOrgName");
        public string CreatebyOrgName
        {
            get { return GetProperty(CreatebyOrgNameProperty); }
            set { SetProperty(CreatebyOrgNameProperty, value); }
        }

        public static readonly PropertyInfo<DateTime> CreatebyDateProperty = RegisterProperty<DateTime>(c => c.CreatebyDate, "CreatebyDate");
        public DateTime CreatebyDate
        {
            get { return GetProperty(CreatebyDateProperty); }
            set { SetProperty(CreatebyDateProperty, value); }
        }

        public static readonly PropertyInfo<string> MaterialEnNameProperty = RegisterProperty<string>(c => c.MaterialEnName, "MaterialEnName");
        public string MaterialEnName
        {
            get { return GetProperty(MaterialEnNameProperty); }
            set { SetProperty(MaterialEnNameProperty, value); }
        }

        public static readonly PropertyInfo<string> LabelCodeProperty = RegisterProperty<string>(c => c.LabelCode, "LabelCode");
        public string LabelCode
        {
            get { return GetProperty(LabelCodeProperty); }
            set { SetProperty(LabelCodeProperty, value); }
        }

        public static readonly PropertyInfo<string> CustomerCodeProperty = RegisterProperty<string>(c => c.CustomerCode, "CustomerCode");
        public string CustomerCode
        {
            get { return GetProperty(CustomerCodeProperty); }
            set { SetProperty(CustomerCodeProperty, value); }
        }

        #endregion
    }

    [Serializable]
    public class BsMaterialList : BusinessListBase<BsMaterialList, BsMaterial>
    {
        public BsMaterialList()
        {
        }
    }

}
