﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using System.Diagnostics;

namespace Wcdf.AppClient4WPF
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        protected override void OnStartup(StartupEventArgs e)
        {
            //this.MainWindow = new MainWindow();
            //this.MainWindow.Show();
            //return;
            Process thisProc = Process.GetCurrentProcess();
            if (Process.GetProcessesByName(thisProc.ProcessName).Length > 1)
            {
                MessageBox.Show("系统已经运行.");
                //System.Environment.Exit(0); 
                Application.Current.Shutdown();
                return;
            }
            //处理未捕获的异常  
            Application.Current.DispatcherUnhandledException += new System.Windows.Threading.DispatcherUnhandledExceptionEventHandler(Current_DispatcherUnhandledException);
            //处理非UI线程异常  
            AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(CurrentDomain_UnhandledException);

            this.ShutdownMode = System.Windows.ShutdownMode.OnExplicitShutdown;
            Login lg = new Login();
            var dlg = lg.ShowDialog();
            if (dlg ?? false)
            {
                //this.StartupUri = new Uri("MainWindow.xaml",UriKind.Relative);
                //this.ShutdownMode = System.Windows.ShutdownMode.OnLastWindowClose;
                this.MainWindow = new MainWindow();
                this.MainWindow.Show();
                //lg.Close();
            }
            else
                Application.Current.Shutdown();
            base.OnStartup(e);
        }

        void CurrentDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e)
        {
        }

        void Current_DispatcherUnhandledException(object sender, System.Windows.Threading.DispatcherUnhandledExceptionEventArgs e)
        {
            string str = "";
            Exception error = e.Exception;
            while (error.InnerException != null)
            {
                error = error.InnerException;
            }
            string strDateInfo = "出现应用程序未处理的异常：" + DateTime.Now.ToString() + "\r\n";
            if (error != null)
            {
                str = string.Format(strDateInfo + "Application UnhandledException:{0};\n\r堆栈信息:{1}", error.Message, error.StackTrace);
            }
            else
            {
                str = string.Format("Application UnhandledError:{0}", e);
            }

            //writeLog(str);
            MessageBox.Show("发生致命错误，请停止当前操作并及时联系作者！" + "\r\n" + str, "系统错误", MessageBoxButton.OKCancel);

            //throw new NotImplementedException();
            e.Handled = true;
        }
    }
}
