﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Wcdf.SysProvide.Model;
using Wcdf.AppClient4WPF.ViewModel;
using Wcdf.Control.OutlookBar;
using Wcdf.Control.TabControlEx;

namespace Wcdf.AppClient4WPF
{
    /// <summary>
    /// Interaction logic for FuncMenu.xaml
    /// </summary>
    public partial class FuncMenu : UserControl
    {
        MainWindow hostWindow;
        private EventHandler<MouseButtonEventArgs> TreeNodeDoubleClick;

        public FuncMenu()
        {
            InitializeComponent();
            //TreeNodeDoubleClick = OnTreeNodeDoubleClick;
        }

        public void BuildMenu(MainWindow host)
        {
            var vm = this.LayoutRoot.DataContext as FuncMenuViewModel;
            //指定Form在哪个控件打开
            this.hostWindow = host;
            //var itemstyle = new System.Windows.Style();
            //itemstyle.ss
            vm.GetFuncMenu();
            foreach (var item in vm.MainMenu)
            {
                var dc = new PermissionTree()
                {
                    Node = item
                };
                vm.GetChildNodes(dc);
                if (dc.ChildNodes == null)
                    continue;
                TreeView trv = new TreeView();
                trv.ItemTemplate = (DataTemplate)this.Resources["TreeViewTemplate"];
                trv.ItemsSource = dc.ChildNodes;
                trv.ItemContainerStyle = (Style)this.Resources["ItemDC"]; ;

                //trv.ItemContainerStyle.TargetType = typeof(TreeViewItem);
                //var dlc = new EventSetter();
                //dlc.Event = TreeViewItem.MouseDoubleClickEvent;
                //dlc.Handler = TreeNodeDoubleClick;
                //trv.ItemContainerStyle.Setters.Add(dlc);
                //var trv = (DataTemplate)this.Resources["trvTemplate"];               
                OutlookBarItem ti = new OutlookBarItem()
                {
                    Header = item.PermissionName,
                    Title = item.PermissionName
                    //内容模板                    
                    //ContentTemplate = trv;
                };
                ti.Content = trv;
                //trv.MouseDoubleClick += new MouseButtonEventHandler(trv_MouseDoubleClick);                
                this.barMenu.Items.Add(ti);
            }
        }

        void OnTreeNodeDoubleClick(object sender, MouseButtonEventArgs mouseEvtArgs)
        {
            var item = sender as TreeViewItem;
            //具有子对象时,过滤掉,当子级双击时会引发父级事件
            if (item.HasItems)
                return;
            //if (mouseEvtArgs.RoutedEvent == TreeViewItem.ExpandedEvent)
            //    return;
            var func = (item.DataContext as PermissionTree).Node;//((sender as TreeView).SelectedItem as PermissionTree).Node;
            if (!string.IsNullOrEmpty(func.ModuleFormClass))
            {
                //有连接的表示可打开窗体
                hostWindow.OpenChildPage(func.PermissionName, func.ModuleFormClass, func.IsSingleForm == "T");
            }
        }
    }
}
