﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Wcdf.Control.TabControlEx;

namespace Wcdf.AppClient4WPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
            this.txtUser.Text += (ApplicationContext.User.Identity as Wcdf.Security.WcdfIdentity).UserInfo.UserID;
            this.txtCom.Text += (ApplicationContext.User.Identity as Wcdf.Security.WcdfIdentity).UserInfo.CorpOrgName;            
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            this.funcMenu.BuildMenu(this);
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            Application.Current.Shutdown();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            this.funcMenu.BuildMenu(this);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="menuName"></param>
        /// <param name="childFullName"></param>
        /// <param name="isSingle"></param>
        public void OpenChildPage(string menuName, string childFullName, bool isSingle)
        {
            Type ChildType = Type.GetType(childFullName);
            //无该类型
            if (null == ChildType)
            {
                //未找到该菜单，请联系管理员检查菜单设置
                MessageBox.Show("未找到该菜单，请联系管理员检查菜单设置");
                return;
            }            
            foreach (var item in this.tabControlEx1.Items)
            {
                if (item is TabItemEx)
                {
                    //var a = item as Wcdf.Control.TabControlEx.ContentTabView;
                    //a
                    var ti = item as Wcdf.Control.TabControlEx.TabItemEx;
                    if (ti.Header == menuName)
                    {
                        ti.IsSelected = true;
                        return;
                    }
                }
            }
            
            System.Windows.Controls.Control page = Wcdf.Reflection.MethodCaller.CreateInstance(ChildType) as System.Windows.Controls.Control;
            TabItemEx newpa = new TabItemEx();
            newpa.Header = menuName;
            newpa.Content = page;
            this.tabControlEx1.Items.Add(newpa);
            newpa.IsSelected = true;
        }
    }
}
