﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Wcdf.SysProvide.Model;

namespace Wcdf.AppClient4WPF.ViewModel
{
    /// <summary>
    /// 菜单树
    /// </summary>
    public class FuncMenuViewModel : FrameworkElement
    {
        public SysPermissionList FuncList { get; set; }
        public List<SysPermission> MainMenu { get; set; }

        public FuncMenuViewModel()
        {
            FuncList = new SysPermissionList();
            MainMenu = new List<SysPermission>();
            //if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(this))
            //{
            //    GetFuncMenu();
            //}
        }

        public void GetFuncMenu()
        {
            var tree = new List<SysPermission>();
            FuncList = Wcdf.DataPortal.Invoke<Wcdf.SysProvide.Model.ISysPortal, SysPermissionList>(o => o.GetFuncMenu());
            var query = FuncList.Where(o => string.IsNullOrEmpty(o.ParentID));
            foreach (var item in query)
            {
                this.MainMenu.Add(item);
                //this.FuncTree.Add(item);
                //BuildTree(item, result);
            }
        }

        private void BuildTree(SysPermission parent, SysPermissionList list)
        {
            var query = list.Where(o => o.ParentID == parent.PermissionID);
            foreach (var item in query)
            {
                BuildTree(item, list);
            }
        }

        public PermissionTree GetChildNodes(PermissionTree parent)
        {
            //List<SysPermission> rav = new List<SysPermission>();
            var query = this.FuncList.Where(o => o.ParentID == parent.Node.PermissionID);
            foreach (var item in query)
            {
                var pt = new ViewModel.PermissionTree();
                pt.Node = item;
                GetChildNodes(pt);
                parent.ChildNodes.Add(pt);
            }
            return parent;
        }
    }
}
