﻿using System.Windows;
using System.Windows.Controls;

namespace Wcdf.Control.OutlookBar
{
    public class OutlookBar : TabControl
    {
        public OutlookBar()
        {
            DefaultStyleKey = typeof(OutlookBar);

            TabStripPlacement = Dock.Bottom;

            SelectionChanged += (s, e) =>
            {
                SelectedTitle = ((OutlookBarItem)SelectedItem).Title;
            };
        }

        #region UI Property
        public static DependencyProperty SelectedTitleProperty = DependencyProperty.Register("SelectedTitle",
                                                                                              typeof(object),
                                                                                              typeof(OutlookBar),
                                                                                              new PropertyMetadata(null));

        public object SelectedTitle
        {
            get { return GetValue(SelectedTitleProperty); }
            set { SetValue(SelectedTitleProperty, value); }
        }
        #endregion

        protected override DependencyObject GetContainerForItemOverride()
        {
            return new OutlookBarItem();
        }

        protected override bool IsItemItsOwnContainerOverride(object item)
        {
            return (item is OutlookBarItem);
        }
    }
}
