﻿using System.Windows;
using System.Windows.Controls;
using Wcdf.ToolClass;
using Wcdf.SysProvide.Model;
using System.ComponentModel;

namespace Wcdf.SysProvide.Client
{
    /// <summary>
    /// Interaction logic for UOrganizationTree.xaml
    /// </summary>
    public partial class UOrganizationTree : UserControl
    {
        public UOrganizationTree()
        {
            InitializeComponent();
            this.TreeView.SelectedItemChanged += new RoutedPropertyChangedEventHandler<object>(trv_SelectedItemChanged);            
            //this.trv.SourceUpdated += new EventHandler<DataTransferEventArgs>(trv_SourceUpdated);            
        }     

        void trv_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            this.SelectedEntity = this.TreeView.SelectedItem as EntityTree<SysOrganizationList,SysOrganization>;
            this.SelectedValue = this.SelectedEntity.Node;
            this.SelectedItem = this.SelectedEntity.Node;
        }       

        public static readonly DependencyProperty SelectedValueProperty =
        DependencyProperty.Register("SelectedValue", typeof(SysOrganization), typeof(UOrganizationTree), new PropertyMetadata(null));
        /// <summary>
        /// 
        /// </summary>
        public SysOrganization SelectedValue
        {
            get { return (SysOrganization)GetValue(SelectedValueProperty); }
            set { SetValue(SelectedValueProperty, value); }
        }
     
        #region UI
        public static readonly DependencyProperty SelectedItemProperty =
        DependencyProperty.Register("SelectedItem", typeof(SysOrganization), typeof(UOrganizationTree),
        new FrameworkPropertyMetadata(null,
            new PropertyChangedCallback(SelectItemCallback)));
        /// <summary>
        /// 
        /// </summary>
        public Wcdf.SysProvide.Model.SysOrganization SelectedItem
        {
            get { return (SysOrganization)GetValue(SelectedItemProperty); }
            set { SetValue(SelectedItemProperty, value); }
        }

        public static readonly DependencyProperty SelectedEntityProperty =
       DependencyProperty.Register("SelectedEntity", typeof(EntityTree<SysOrganizationList, SysOrganization>), typeof(UOrganizationTree),
       new PropertyMetadata(null));
        //private EntityTree<SysOrganizationList, SysOrganization> _entity;
        public EntityTree<SysOrganizationList, SysOrganization> SelectedEntity
        {
            get { return (EntityTree<SysOrganizationList, SysOrganization>)GetValue(SelectedEntityProperty); }
            set { SetValue(SelectedEntityProperty, value); }
        }

        private static void SelectItemCallback(DependencyObject sender, DependencyPropertyChangedEventArgs arg)
        {            
            if (sender != null && sender is UOrganizationTree)
            {
                var ctrl = sender as UOrganizationTree;
                ctrl.OnSelectItem((SysOrganization)arg.OldValue, (SysOrganization)arg.NewValue);

            }
        }

        protected virtual void OnSelectItem(SysOrganization oldValue, SysOrganization newValue)
        {
            RoutedPropertyChangedEventArgs<SysOrganization> arg =
                new RoutedPropertyChangedEventArgs<SysOrganization>(oldValue, newValue, SelectItemEvent);
            //Wcdf.Xaml.ExecuteEventArgs arg = new Xaml.ExecuteEventArgs();
            //args.MethodParameter = newValue;
            this.RaiseEvent(arg);

        } 

        public static readonly RoutedEvent SelectItemEvent =
            EventManager.RegisterRoutedEvent("SelectItem",
             RoutingStrategy.Bubble, typeof(RoutedPropertyChangedEventHandler<SysOrganization>), typeof(UOrganizationTree));
        [Description("选择后更新后发生")]
        public event RoutedPropertyChangedEventHandler<SysOrganization> SelectItem
        {
            add
            {
                this.AddHandler(SelectItemEvent, value);
            }
            remove
            {
                this.RemoveHandler(SelectItemEvent, value);
            }
        }
        #endregion       
    }
}
