﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf.Xaml;
using Wcdf.SysProvide.Model;
using System.Windows;
using Wcdf.ToolClass;
using System.Collections.ObjectModel;
using System.Windows.Controls;

namespace Wcdf.SysProvide.Client.ViewModel
{
    public class SysOrganizationVM : ViewModel<SysOrganization>
    {
        public SysOrganizationVM()
        {

            if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(this))
            {
                //DoRefresh(() => Wcdf.DataPortal.Fetch<SysOrganizationList>());                
            }
        }

        /// <summary>
        /// 增加子节点
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void AddChild(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            var pitem = (e.MethodParameter as UOrganizationTree).SelectedEntity as EntityTree<Wcdf.SysProvide.Model.SysOrganizationList, Wcdf.SysProvide.Model.SysOrganization>;
            var child = new SysOrganization();
            this.Model = child;
            child.KeyID = Guid.NewGuid();
            child.OrgID = CreateChildOrgID(pitem);
            child.ParentOrgID = pitem.Node.OrgID;
            //if (pitem.ChildNodes == null)
            //{
            //    pitem.ChildNodes = new ObservableCollection<EntityTree<SysOrganizationList, SysOrganization>>();
            //}
            var item = new EntityTree<SysOrganizationList, SysOrganization>();
            child.OrgName = "请输入";
            item.Parent = pitem;
            item.Node = child;
            pitem.AddNewItem(item);
            //pitem.ChildNodes.Add(item);
            (e.MethodParameter as UOrganizationTree).SelectedEntity = item;
        }

        public void DelChild(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            var pitem = (e.MethodParameter as UOrganizationTree).SelectedEntity 
                as EntityTree<Wcdf.SysProvide.Model.SysOrganizationList, Wcdf.SysProvide.Model.SysOrganization>;
            if (pitem.ChildNodes != null && pitem.ChildNodes.Count != 0)
            {
                MessageBox.Show("包括有下级组织,不能删除!");
                return;
            }            
            this.Model.Parent.RemoveChild(pitem.Node);
            (this.Model.Parent as Wcdf.Core.ISavable).Save();
            //界面上删除
            pitem.Parent.ChildNodes.Remove(pitem);            
            
            //this.Delete(sender, e);
        }

        public void SaveNew(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            //var pitem = e.MethodParameter as EntityTree<SysOrganizationList, SysOrganization>;
            var item = this.Model;
            this.Save(sender, e);
        }
        /// <summary>
        /// 创建子级最大ID
        /// </summary>
        /// <param name="parent"></param>
        /// <returns></returns>
        private string CreateChildOrgID(EntityTree<Wcdf.SysProvide.Model.SysOrganizationList, Wcdf.SysProvide.Model.SysOrganization> parent)
        {
            //int result = 0;
            if (parent.ChildNodes == null || parent.ChildNodes.Count == 0)
                return parent.Node.OrgID + "01";
            var query = from nodes in parent.ChildNodes
                        select nodes.Node.OrgID;
            var max = query.Max();
            string maxID = (int.Parse(max.Substring(max.Length - 2)) + 1).ToString();
            maxID = maxID.PadLeft(2, '0');
            return parent.Node.OrgID + maxID;
        }
    }
}
