﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using Wcdf.Data;
using Wcdf.SysProvide.Model;
using Wcdf.Xaml;

namespace Wcdf.SysProvide.Client.ViewModel
{
    public class SysRoleListVM : ViewModel<SysRoleList>
    {
        public void GetRoleList(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            //e.TriggerParameter as 
            string orgID = (e.MethodParameter as SysOrganization).OrgID;
            Criteria cri = new Criteria();
            cri.AddFilter<SysRole>(o => o.OrgID.StartsWith(orgID));
            this.DoRefresh(() => DataPortal.Fetch<SysRoleList>(cri));
        }

        public void AddNewUser(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            SysOrganization org = e.MethodParameter as SysOrganization;
            var nu = this.Model.AddNew();
            nu.KeyID = Guid.NewGuid();
            nu.OrgID = org.OrgID;
            nu.OrgName = org.OrgName;
        }        
    }
}
