﻿using Wcdf.Xaml;
using Wcdf.SysProvide.Model;
using Wcdf.Data;
using System.Windows;
using System;

namespace Wcdf.SysProvide.Client.ViewModel
{
    public class SysUserListVM:ViewModel<SysUserList>
    {
        public SysUserListVM()
        {

        }

        public void GetUserList(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            //e.TriggerParameter as 
            string orgID = (e.MethodParameter as SysOrganization).OrgID;
            Criteria cri = new Criteria();
            cri.AddFilter<SysUser>(o => o.OrgID.Equals(orgID));
            this.DoRefresh(()=>DataPortal.Fetch<SysUserList>(cri));
        }

        public void AddNewUser(object sender, Wcdf.Xaml.ExecuteEventArgs e)
        {
            SysOrganization org = e.MethodParameter as SysOrganization;
            var nu = this.Model.AddNew();
            nu.KeyID = Guid.NewGuid();
            nu.OrgID = org.OrgID;
            nu.OrgName = org.OrgName;
        }

        #region UI
        public static readonly DependencyProperty OrgIDProperty =
        DependencyProperty.Register("OrgID", typeof(string), typeof(SysUserListVM), new PropertyMetadata(null));
        /// <summary>
        /// 
        /// </summary>
        public string OrgID
        {
            get { return (string)GetValue(OrgIDProperty); }
            set { SetValue(OrgIDProperty, value); }
        }
        #endregion
    }
}
