﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf;
using System.ComponentModel.DataAnnotations;

namespace Wcdf.SysProvide.Model
{

    [Serializable]
    public class SysCodeDict : BusinessBase<SysCodeDict>
    {
        #region MapperName
        public override string GetDataObjectName()
        {
            return "sys_code_dict";
        }
        #endregion

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
        }

        #region Data Feild Property

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID",RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> CodeTypeProperty = RegisterProperty<string>(c => c.CodeType, "CodeType");
        [Required()]
        public string CodeType
        {
            get { return GetProperty(CodeTypeProperty); }
            set { SetProperty(CodeTypeProperty, value); }
        }

        public static readonly PropertyInfo<string> CodeKeyProperty = RegisterProperty<string>(c => c.CodeKey, "CodeKey");
        [Required(ErrorMessage="编码必填")]
        public string CodeKey
        {
            get { return GetProperty(CodeKeyProperty); }
            set { SetProperty(CodeKeyProperty, value); }
        }

        public static readonly PropertyInfo<string> CodeValueProperty = RegisterProperty<string>(c => c.CodeValue, "CodeValue");
        [Required(ErrorMessage="名称必填")]
        public string CodeValue
        {
            get { return GetProperty(CodeValueProperty); }
            set { SetProperty(CodeValueProperty, value); }
        }

        public static readonly PropertyInfo<string> RemarksProperty = RegisterProperty<string>(c => c.Remarks, "Remarks");
        public string Remarks
        {
            get { return GetProperty(RemarksProperty); }
            set { SetProperty(RemarksProperty, value); }
        }
        #endregion
    }

    [Serializable]
    public class SysCodeDictList : BusinessListBase<SysCodeDictList, SysCodeDict>
    {
        public SysCodeDictList()
        {
        }
    }

}
