﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf;
using System.ComponentModel.DataAnnotations;
using Wcdf.Rules.CommonRules;

namespace Wcdf.SysProvide.Model
{

    [Serializable]
    public class SysCodeType : BusinessBase<SysCodeType>
    {
        #region MapperName
        public override string GetDataObjectName()
        {
            return "sys_code_type";
        }
        #endregion

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
            BusinessRules.AddRule(new Required(CodeTypeProperty, "编码必输入."));
            BusinessRules.AddRule(new Required(CodeTypeNameProperty, "名称必输入."));
        }

        #region Data Feild Property

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID",RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> CodeTypeProperty = RegisterProperty<string>(c => c.CodeType, "CodeType");
        public string CodeType
        {
            get { return GetProperty(CodeTypeProperty); }
            set { SetProperty(CodeTypeProperty, value); }
        }

        public static readonly PropertyInfo<string> CodeTypeNameProperty = RegisterProperty<string>(c => c.CodeTypeName, "CodeTypeName");
        public string CodeTypeName
        {
            get { return GetProperty(CodeTypeNameProperty); }
            set { SetProperty(CodeTypeNameProperty, value); }
        }

        public static readonly PropertyInfo<string> RemarksProperty = RegisterProperty<string>(c => c.Remarks, "Remarks");
        public string Remarks
        {
            get { return GetProperty(RemarksProperty); }
            set { SetProperty(RemarksProperty, value); }
        }

        public static readonly PropertyInfo<string> DataTypeProperty = RegisterProperty<string>(c => c.DataType, "DataType");
        public string DataType
        {
            get { return GetProperty(DataTypeProperty); }
            set { SetProperty(DataTypeProperty, value); }
        }

        public static readonly PropertyInfo<string> DataLengthProperty = RegisterProperty<string>(c => c.DataLength, "DataLength");
        public string DataLength
        {
            get { return GetProperty(DataLengthProperty); }
            set { SetProperty(DataLengthProperty, value); }
        }

        public static readonly PropertyInfo<string> ParentKeyIDProperty = RegisterProperty<string>(c => c.ParentKeyID, "ParentKeyID");
        public string ParentKeyID
        {
            get { return GetProperty(ParentKeyIDProperty); }
            set { SetProperty(ParentKeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> CodeClassProperty = RegisterProperty<string>(c => c.CodeClass, "CodeClass");
        public string CodeClass
        {
            get { return GetProperty(CodeClassProperty); }
            set { SetProperty(CodeClassProperty, value); }
        }

        public static readonly PropertyInfo<string> IsClassProperty = RegisterProperty<string>(c => c.IsClass, "IsClass");
        public string IsClass
        {
            get { return GetProperty(IsClassProperty); }
            set { SetProperty(IsClassProperty, value); }
        }

        #endregion
    }

    [Serializable]
    public class SysCodeTypeList : BusinessListBase<SysCodeTypeList, SysCodeType>
    {
        public SysCodeTypeList()
        {
        }
    }

}
