﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf;
using System.ComponentModel.DataAnnotations;

namespace Wcdf.SysProvide.Model
{
    [Serializable]
    public class SysOrganization : BusinessBase<SysOrganization>
    {
        #region MapperName
        public override string GetDataObjectName()
        {
            return "sys_organization";
        }
        #endregion

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
        }

        #region Data Feild Property

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID",RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgIDProperty = RegisterProperty<string>(c => c.OrgID, "OrgID");
        public string OrgID
        {
            get { return GetProperty(OrgIDProperty); }
            set { SetProperty(OrgIDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgNameProperty = RegisterProperty<string>(c => c.OrgName, "OrgName");
        public string OrgName
        {
            get { return GetProperty(OrgNameProperty); }
            set { SetProperty(OrgNameProperty, value); }
        }

        public static readonly PropertyInfo<string> ParentOrgIDProperty = RegisterProperty<string>(c => c.ParentOrgID, "ParentOrgID");
        public string ParentOrgID
        {
            get { return GetProperty(ParentOrgIDProperty); }
            set { SetProperty(ParentOrgIDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgTypeCDProperty = RegisterProperty<string>(c => c.OrgTypeCD, "OrgTypeCD");
        public string OrgTypeCD
        {
            get { return GetProperty(OrgTypeCDProperty); }
            set { SetProperty(OrgTypeCDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgManagerProperty = RegisterProperty<string>(c => c.OrgManager, "OrgManager");
        public string OrgManager
        {
            get { return GetProperty(OrgManagerProperty); }
            set { SetProperty(OrgManagerProperty, value); }
        }

        public static readonly PropertyInfo<string> TelProperty = RegisterProperty<string>(c => c.Tel, "Tel");
        public string Tel
        {
            get { return GetProperty(TelProperty); }
            set { SetProperty(TelProperty, value); }
        }

        public static readonly PropertyInfo<string> FaxProperty = RegisterProperty<string>(c => c.Fax, "Fax");
        public string Fax
        {
            get { return GetProperty(FaxProperty); }
            set { SetProperty(FaxProperty, value); }
        }

        public static readonly PropertyInfo<string> PostalCodeProperty = RegisterProperty<string>(c => c.PostalCode, "PostalCode");
        public string PostalCode
        {
            get { return GetProperty(PostalCodeProperty); }
            set { SetProperty(PostalCodeProperty, value); }
        }

        public static readonly PropertyInfo<string> AddressProperty = RegisterProperty<string>(c => c.Address, "Address");
        public string Address
        {
            get { return GetProperty(AddressProperty); }
            set { SetProperty(AddressProperty, value); }
        }

        public static readonly PropertyInfo<DateTime> SetUpDateProperty = RegisterProperty<DateTime>(c => c.SetUpDate, "SetUpDate");
        public DateTime SetUpDate
        {
            get { return GetProperty(SetUpDateProperty); }
            set { SetProperty(SetUpDateProperty, value); }
        }

        public static readonly PropertyInfo<string> RemarksProperty = RegisterProperty<string>(c => c.Remarks, "Remarks");
        public string Remarks
        {
            get { return GetProperty(RemarksProperty); }
            set { SetProperty(RemarksProperty, value); }
        }

        #endregion
    }

    [Serializable]
    public class SysOrganizationList : BusinessListBase<SysOrganizationList, SysOrganization>
    {
        public SysOrganizationList()
        {
        }
    }

}
