﻿using System;
using System.ComponentModel.DataAnnotations;

namespace Wcdf.SysProvide.Model
{
    [Serializable]
    public class SysPermission : BusinessBase<SysPermission>
    {
        #region MapperName
        public override string GetDataObjectName()
        {
            return "sys_permission";
        }
        #endregion

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
        }

        [RunLocal]
        protected override void DataPortal_Create(object criteria)
        {
            base.DataPortal_Create(criteria);
            this.KeyID = Guid.NewGuid();
        }

        #region Data Feild Property

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID", RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> PermissionIDProperty = RegisterProperty<string>(c => c.PermissionID, "PermissionID");
        [Required(ErrorMessage = "权限代码不能为空")]
        public string PermissionID
        {
            get { return GetProperty(PermissionIDProperty); }
            set { SetProperty(PermissionIDProperty, value); }
        }

        public static readonly PropertyInfo<string> PermissionNameProperty = RegisterProperty<string>(c => c.PermissionName, "PermissionName");
        public string PermissionName
        {
            get { return GetProperty(PermissionNameProperty); }
            set { SetProperty(PermissionNameProperty, value); }
        }

        public static readonly PropertyInfo<string> ParentIDProperty = RegisterProperty<string>(c => c.ParentID, "ParentID");
        public string ParentID
        {
            get { return GetProperty(ParentIDProperty); }
            set { SetProperty(ParentIDProperty, value); }
        }

        public static readonly PropertyInfo<int> PermissonTypeProperty = RegisterProperty<int>(c => c.PermissonType, "PermissonType");
        public int PermissonType
        {
            get { return GetProperty(PermissonTypeProperty); }
            set { SetProperty(PermissonTypeProperty, value); }
        }

        public static readonly PropertyInfo<string> RemarkProperty = RegisterProperty<string>(c => c.Remark, "Remark");
        public string Remark
        {
            get { return GetProperty(RemarkProperty); }
            set { SetProperty(RemarkProperty, value); }
        }

        public static readonly PropertyInfo<string> ModuleFormClassProperty = RegisterProperty<string>(c => c.ModuleFormClass, "ModuleFormClass");
        public string ModuleFormClass
        {
            get { return GetProperty(ModuleFormClassProperty); }
            set { SetProperty(ModuleFormClassProperty, value); }
        }

        public static readonly PropertyInfo<int> SortProperty = RegisterProperty<int>(c => c.Sort, "Sort");
        public int Sort
        {
            get { return GetProperty(SortProperty); }
            set { SetProperty(SortProperty, value); }
        }

        public static readonly PropertyInfo<string> IsSingleFormProperty = RegisterProperty<string>(c => c.IsSingleForm, "IsSingleForm");

        public string IsSingleForm
        {
            get { return GetProperty(IsSingleFormProperty); }
            set { SetProperty(IsSingleFormProperty, value); }
        }

        public static readonly PropertyInfo<string> EnableProperty = RegisterProperty<string>(c => c.Enable, "Enable");
        public string Enable
        {
            get { return GetProperty(EnableProperty); }
            set { SetProperty(EnableProperty, value); }
        }
        #endregion
    }

    [Serializable]
    public class SysPermissionList : BusinessListBase<SysPermissionList, SysPermission>
    {
        public SysPermissionList()
        {
        }
    }

}
