﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf;
using System.ComponentModel.DataAnnotations;

namespace Wcdf.SysProvide.Model
{
    [Transactional(TransactionalTypes.TransactionScope)]
    [Serializable]
    public class SysRole : BusinessBase<SysRole>
    {
        #region MapperName
        public override string GetDataObjectName()
        {
            return "sys_role";
        }
        #endregion

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
            BusinessRules.AddRule(new Wcdf.Rules.CommonRules.Required(RoleIDProperty,"角色ID必输"));
        }

        #region Data Feild Property

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID",RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> RoleIDProperty = RegisterProperty<string>(c => c.RoleID, "RoleID");
        public string RoleID
        {
            get { return GetProperty(RoleIDProperty); }
            set { SetProperty(RoleIDProperty, value); }
        }

        public static readonly PropertyInfo<string> RoleNameProperty = RegisterProperty<string>(c => c.RoleName, "RoleName");
        public string RoleName
        {
            get { return GetProperty(RoleNameProperty); }
            set { SetProperty(RoleNameProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgIDProperty = RegisterProperty<string>(c => c.OrgID, "OrgID");
        public string OrgID
        {
            get { return GetProperty(OrgIDProperty); }
            set { SetProperty(OrgIDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgNameProperty = RegisterProperty<string>(c => c.OrgName, "OrgName");
        public string OrgName
        {
            get { return GetProperty(OrgNameProperty); }
            set { SetProperty(OrgNameProperty, value); }
        }

        public static readonly PropertyInfo<string> RemarkProperty = RegisterProperty<string>(c => c.Remark, "Remark");
        public string Remark
        {
            get { return GetProperty(RemarkProperty); }
            set { SetProperty(RemarkProperty, value); }
        }

        public static readonly PropertyInfo<string> IsUserProperty = RegisterProperty<string>(c => c.IsUser, "IsUser");
        public string IsUser
        {
            get { return GetProperty(IsUserProperty); }
            set { SetProperty(IsUserProperty, value); }
        }

        #endregion
    }

    [Serializable]
    public class SysRoleList : BusinessListBase<SysRoleList, SysRole>
    {
        public SysRoleList()
        {
        }
    }

}
