﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel.DataAnnotations;
using Wcdf.Rules.CommonRules;

namespace Wcdf.SysProvide.Model
{
    [Serializable]
    public class SysUser:BusinessBase<SysUser>
    {
        public SysUser()
        {
        }

        public override string GetDataObjectName()
        {
            return "sys_user";
        }

        protected override void AddBusinessRules()
        {
            base.AddBusinessRules();
            BusinessRules.AddRule(new Required(UserIDProperty,"用户ID必须输入."));
            //Wcdf.Rules.CommonRules.Required(
        }

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID", RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> UserIDProperty = RegisterProperty<string>(c => c.UserID, "UserID");
        [StringLength(20,ErrorMessage="长度不能大于20")]
        public string UserID
        {
            get { return GetProperty(UserIDProperty); }
            set { SetProperty(UserIDProperty, value); }
        }

        public static readonly PropertyInfo<string> UserNameProperty = RegisterProperty<string>(c => c.UserName,"UserName");
        public string UserName
        {
            get { return GetProperty(UserNameProperty); }
            set { SetProperty(UserNameProperty, value); }
        }

        public static readonly PropertyInfo<string> PasswordProperty = RegisterProperty<string>(c => c.Password,"Password");
        public string Password
        {
            get { return GetProperty(PasswordProperty); }
            set { SetProperty(PasswordProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgIDProperty = RegisterProperty<string>(c => c.OrgID,"OrgID");
        public string OrgID
        {
            get { return GetProperty(OrgIDProperty); }
            set { SetProperty(OrgIDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgNameProperty = RegisterProperty<string>(c => c.OrgName, "OrgName");
        public string OrgName
        {
            get { return GetProperty(OrgNameProperty); }
            set { SetProperty(OrgNameProperty, value); }
        }

        public static readonly PropertyInfo<string> IsActiveProperty = RegisterProperty<string>(c => c.IsActive, "IsActive");
        public string IsActive
        {
            get { return GetProperty(IsActiveProperty); }
            set { SetProperty(IsActiveProperty, value); }
        }

        public static readonly PropertyInfo<string> IsCanLoginProperty = RegisterProperty<string>(c => c.IsCanLogin, "IsCanLogin");
        public string IsCanLogin
        {
            get { return GetProperty(IsCanLoginProperty); }
            set { SetProperty(IsCanLoginProperty, value); }
        }
        public static readonly PropertyInfo<string> EmailAddressProperty = RegisterProperty<string>(c => c.EmailAddress, "EmailAddress");
        public string EmailAddress
        {
            get { return GetProperty(EmailAddressProperty); }
            set { SetProperty(EmailAddressProperty, value); }
        }

        public static readonly PropertyInfo<string> JobProperty = RegisterProperty<string>(c => c.Job, "Job");
        public string Job
        {
            get { return GetProperty(JobProperty); }
            set { SetProperty(JobProperty, value); }
        }
    }

    [Serializable]
    public class SysUserList : BusinessListBase<SysUserList, SysUser>
    {
        public SysUserList()
        {
        }
    }
}
