﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf.SysProvide.Model;
using Wcdf.Data;
using Wcdf.Server;

namespace Wcdf.SysProvide.Service
{
    public class SysPortal : ISysPortal
    {
        /// <summary>
        /// 登陆验证,返回登陆信息.
        /// </summary>
        /// <param name="userName"></param>
        /// <param name="password"></param>
        /// <param name="infos"></param>
        /// <returns></returns>
        public Wcdf.Server.DataPortalResult UserLogin(string loginID, string password, string orgID, string orgName,params object[] infos)
        {
            StringBuilder sql = new StringBuilder();
            DataPortalResult result; 
            DataAccess da = new DataAccess();
            if (loginID != "admin")
            {
                sql.AppendFormat(@"select 1 from sys_organization o,sys_role_user u,sys_role r
                            where o.OrgTypeCD = '80A'  
                              and o.OrgID = '{0}'        
                              and r.OrgID like o.OrgID+'%'
                              and u.RoleID = r.RoleID
                              and u.UserID = '{1}')", orgID, loginID);
                
                var ss = da.ExecuteScalar(sql.ToString());
                if (ss == null)
                {
                    result = new DataPortalResult("该用户不属于所选择公司.");
                    return result;
                }
            }
            var uinfo = new Wcdf.Security.UserInfo();

            #region 取用户信息
            Criteria cr = new Criteria();
            cr.AddFilter<SysUser>(o => o.UserID == loginID);
            SysUser user = Wcdf.DataPortal.Fetch<SysUser>(cr);
            uinfo.UserID = user.UserID;
            uinfo.UserName = user.UserName;
            uinfo.OrgID = user.OrgID;
            uinfo.OrgName = user.OrgName;
            uinfo.CorpOrgID = orgID;
            uinfo.CorpOrgName = orgName;
            #endregion

            #region 取用户角色
            //角色信息
            sql.Clear();
            sql.AppendFormat(@"select sys_role_user.RoleID, sys_role_user.RoleName
                                           from sys_role_user,sys_role
                                          where sys_role_user.UserID = '{0}'
                                            and sys_role_user.RoleID = sys_role.RoleID                                            
                                        ", uinfo.UserID);
            string roleIDList = string.Empty;
            string roleNameList = string.Empty;
            SysRoleList roles = new SysRoleList();
            da.ExecuteList<SysRoleList, SysRole>(roles, sql.ToString());
            foreach (var item in roles)
            {
                roleIDList += item.RoleID + ",";
                roleNameList += item.RoleName + ",";
            }          
            if (!string.IsNullOrEmpty(roleIDList))
            {
                uinfo.RoleID = roleIDList.Remove(roleIDList.Length - 1);
                uinfo.RoleName = roleNameList.Remove(roleNameList.Length - 1);
            }
            else//可能无角色时.默认用户
            {
                uinfo.RoleID = uinfo.UserID;
                uinfo.RoleName = uinfo.UserName;
            }
            #endregion

            var principal = new Wcdf.Security.WcdfPrincipal();
            (principal.Identity as Wcdf.Security.WcdfIdentity).SetUserInfo(uinfo);
            ApplicationContext.User = principal;
            result = new DataPortalResult(ApplicationContext.User, ApplicationContext.GlobalContext);
            return result;
        }

        /// <summary>
        /// 认证用户，取得该用户下的公司列表
        /// </summary>
        /// <param name="loginID">登陆名</param>
        /// <param name="password">明文密码</param>
        /// <returns></returns>
        public SysOrganizationList Authorization(string loginID, string password)
        {
            //Criteria cri = new Criteria();
            SysOrganizationList result = new SysOrganizationList();
            StringBuilder sql = new StringBuilder();
            sql.Append(@"select * from sys_organization
                            where OrgTypeCD = '80A'");
            if (loginID != "admin")
            {
                sql.AppendFormat(@"            
                              and OrgID in(select r.OrgID 
				                             from sys_role_user u,sys_role r 
				                            where u.RoleID = r.RoleID
				                              and u.UserID = '{0}')", loginID);
            }
            DataAccess da = new DataAccess();
            da.ExecuteList<SysOrganizationList, SysOrganization>(result, sql.ToString());
            return result;
        }

        public SysPermissionList GetFuncMenu()
        {
            string roleID;
            //未通过验证时,,些处为测试代码.
            var user = ApplicationContext.User.Identity as Wcdf.Security.WcdfIdentity;
            if (null == user)
                roleID = "'" + ApplicationContext.User.Identity.Name + "'";
            else
                roleID = user.UserInfo.RoleID;
            string[] rids = roleID.Split(',');
            roleID = string.Empty;
            foreach (string rid in rids)
            {
                roleID += "'" + rid + "',"; ;
            }
            roleID = roleID.Remove(roleID.Length - 1);
            StringBuilder sql = new StringBuilder();
            if (user.UserInfo.UserID == "admin")
            {
                sql.Append("select sys_permission.* from sys_permission");
            }
            else
            {
                sql.Append("select distinct sys_permission.* ");
                sql.Append("  from sys_permission,sys_role_permission");
                sql.Append(" where sys_permission.KeyID = sys_role_permission.PermissionKeyID");
                sql.Append("   and sys_permission.PermissonType < 2");
                sql.Append("   and sys_permission.Enable = 'T')");
                sql.AppendFormat("   and sys_role_permission.RoleID in ({0})", roleID);
                //Sql.Append(" order by Sort");
            }
            DataAccess da = new DataAccess();
            var result = new SysPermissionList();
            da.ExecuteList<SysPermissionList, SysPermission>(result, sql.ToString());
            return result;            
        }
    }
}
