﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Core
{
    /// <summary>
    /// 该对象包含了新加对象的信息.该对象应用于列表类型.
    /// </summary>
    /// <typeparam name="T">
    /// 新加入对象的类型
    /// </typeparam>
    public class AddedNewEventArgs<T> : EventArgs
    {
        /// <summary>
        /// Gets a reference to the newly added
        /// object.
        /// </summary>
        public T NewObject { get; protected set; }

        /// <summary>
        /// Creates a new instance of the object.
        /// </summary>
        public AddedNewEventArgs() { }

        /// <summary>
        /// Creates a new instance of the object.
        /// </summary>
        /// <param name="newObject">
        /// The newly added object.
        /// </param>
        public AddedNewEventArgs(T newObject)
        {
            NewObject = newObject;
        }
    }
}
