﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Core
{
    /// <summary>
    /// 未处理的异步异常事件参数.    
    /// </summary>
    public class ErrorEventArgs : EventArgs
    {
        /// <summary>
        /// 原始事件发出对象.
        /// </summary>
        public object OriginalSender { get; protected set; }
        /// <summary>
        /// 未处理的异常
        /// </summary>
        public Exception Error { get; protected set; }

        /// <summary>
        /// Creates an instance of the object.
        /// </summary>
        /// <param name="originalSender">
        /// Reference to the original sender of the event.
        /// </param>
        /// <param name="error">
        /// Reference to the unhandled async exception object.
        /// </param>
        public ErrorEventArgs(object originalSender, Exception error)
        {
            OriginalSender = originalSender;
            Error = error;
        }
    }
}
