﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Core.FieldManager
{
    /// <summary>
    /// 属性信息创建工厂   
    /// </summary>
    public static class PropertyInfoFactory
    {
        private static Wcdf.Core.IPropertyInfoFactory _factory;

        /// <summary>
        /// Gets or sets the factory object that
        /// creates PropertyInfo objects.
        /// </summary>
        public static Wcdf.Core.IPropertyInfoFactory Factory
        {
            get
            {
                if (_factory == null)
                {
#if SILVERLIGHT
          _factory = new DefaultPropertyInfoFactory();
#else
                    var typeName = System.Configuration.ConfigurationManager.AppSettings["CslaPropertyInfoFactory"];
                    if (string.IsNullOrEmpty(typeName))
                    {
                        _factory = new DefaultPropertyInfoFactory();
                    }
                    else
                    {
                        var type = Type.GetType(typeName);
                        _factory = (Wcdf.Core.IPropertyInfoFactory)Activator.CreateInstance(type);
                    }
#endif
                }
                return _factory;
            }
            set
            {
                _factory = value;
            }
        }
    }
}
