﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Core
{
    /// <summary>
    /// 定义业务对象控制业务规则执行开关的方法    
    /// </summary>
    public interface ICheckRules
    {
        /// <summary>
        /// Sets value indicating no rule methods will be invoked.
        /// </summary>
        void SuppressRuleChecking();

        /// <summary>
        /// Resets value indicating all rule methods will be invoked.
        /// </summary>
        void ResumeRuleChecking();

        /// <summary>
        /// Invokes all rules for the business type.
        /// </summary>
        void CheckRules();
    }
}
