﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Core
{
    /// <summary>
    /// 定义可编辑的框架对象所需的通用方法.    
    /// </summary>
    /// <remarks>
    /// 强烈建议,实现方法应该设计为私有的.以便使列表对象的原接口不会发生混乱.
    /// </remarks>
    public interface IEditableBusinessObject : IBusinessObject, ISupportUndo, IUndoableObject, ITrackStatus
    {
        /// <summary>
        /// 只在本程序集中应用!!
        /// </summary>
        /// <remarks>
        /// 更改该值会引起代码错误..该属性是只能由父对象设置        
        /// </remarks>
        int EditLevelAdded { get; set; }
        /// <summary>
        /// 由父对象调用.延迟删除.        
        /// </summary>
        void DeleteChild();
        /// <summary>
        /// 该方法用于BusinessListBase由子对象建立与父对象的联系.         
        /// </summary>
        /// <param name="parent">A reference to the parent collection object.</param>
        void SetParent(IParent parent);
        /// <summary>
        /// 将对象标记为删除.对象将会在保存操作中删除.        
        /// </summary>
        void Delete();
    }
}
