﻿using System.Collections.Generic;

namespace Wcdf.Core
{
    /// <summary>
    /// 提供对维护字段FieldManager中的操作接口.
    /// </summary>
    internal interface IManageProperties
    {
        bool HasManagedProperties { get; }
        bool FieldExists(Wcdf.Core.IPropertyInfo property);
        List<IPropertyInfo> GetManagedProperties();
        object GetProperty(IPropertyInfo propertyInfo);
        object ReadProperty(IPropertyInfo propertyInfo);
        P ReadProperty<P>(PropertyInfo<P> propertyInfo);
        void SetProperty(IPropertyInfo propertyInfo, object newValue);
        void LoadProperty(IPropertyInfo propertyInfo, object newValue);
        void LoadProperty<P>(PropertyInfo<P> propertyInfo, P newValue);
        List<object> GetChildren();
    }
}
