﻿
namespace Wcdf.Core
{
    /// <summary>
    /// 定义了包含子对象的业务对象需求实现的接口    
    /// </summary>
    public interface IParent
    {
        /// <summary>
        /// 该方法由子对象调用.从当前列表中移除        
        /// </summary>
        /// <param name="child">The child object to remove.</param>
        void RemoveChild(Core.IEditableBusinessObject child);
        /// <summary>
        /// 重写该方法来获取通知,当子对象<see cref="Core.BusinessBase.ApplyEdit" />方法完成时.        
        /// </summary>
        /// <param name="child">The child object that was edited.</param>
        void ApplyEditChild(Core.IEditableBusinessObject child);
    }
}
