﻿using System;

namespace Wcdf.Core
{
    /// <summary>
    /// 维护属性元数据
    /// </summary>
    public interface IPropertyInfo : IMemberInfo
    {
        /// <summary>
        /// 取得属性类型
        /// </summary>
        Type Type { get; }
        /// <summary>
        /// 取得字段的友好名称    
        /// </summary>
        string FriendlyName { get; }
        /// <summary>
        /// 取得属性的默认初始化值
        /// </summary>
        /// <remarks>
        /// 该值用于属性初始化,如果用户具有该属性的读取权限,会从属性get方法取得值
        /// </remarks>
        object DefaultValue { get; }
        /// <summary>
        /// 取得属性的新字段数据容器
        /// </summary>
        Core.FieldManager.IFieldData NewFieldData(string name);
        /// <summary>
        /// 取得属性与对象之间的关系
        /// </summary>
        RelationshipTypes RelationshipType { get; }
        /// <summary>
        /// 取得和设置管理字段的位置次序.        
        /// </summary>
        int Index { get; set; }
    }
}
