﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace Wcdf.Data
{
    /// <summary>
    /// 业务对象条件,包括字段语句,Where子句的Filter和排序的Sort子句.
    /// </summary>
    [Serializable]
    public class Criteria
    {        
        /// <summary>
        /// 列信息,以数组形式表现
        /// </summary>
        public string[] Columns { get; set; }
        /// <summary>
        /// 过滤条件
        /// </summary>
        public Filter Filters { get; set; }
        /// <summary>
        ///  排序信息
        /// </summary>
        public OrderBy OrderBy { get; set; }
        /// <summary>
        /// 分页信息
        /// </summary>
        public Paging Paging { get; set; }

        /// <summary>
        /// 默认的初始化
        /// </summary>
        public Criteria()
        {
            Filters = new Filter();
        }

        #region Add Filter
        /// <summary>
        /// 增加过滤条件
        /// </summary>        
        public void AddFilter(Filter filter)
        {
            this.Filters.ChildFilter.Add(filter);
        }

        /// <summary>
        /// 直接加入语句.
        /// </summary>
        public void AddFilter(string sqlFilter)
        {
            this.Filters.SetCondition(sqlFilter);
        }

        public void AddFilter<TBusiness>(Expression<Func<TBusiness, bool>> predicate)
        {
            //ConditionBuilder conditionBuilder = new ConditionBuilder();
            //conditionBuilder.Build(predicate.Body);
            //Filter filter = new Filter(string.Format(conditionBuilder.Condition,conditionBuilder.Arguments));
            this.Filters.SetCondition(predicate);
        }
        #endregion

    }
}
