﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Data
{
    /// <summary>
    /// ORM内部的数据类型
    /// </summary>
    /// <remarks>通过与具体数据库的数据类型对应
    /// </remarks>
    public enum DBType
    {
        /// <summary>
        /// 不定长字符型
        /// </summary>
        String = 0,

        /// <summary>
        /// 32位整数
        /// </summary>
        Int = 1,

        /// <summary>
        /// 64位整数
        /// </summary>
        BigInt = 2,

        /// <summary>
        /// 定长的二进制数据
        /// </summary>
        Binary = 3,

        /// <summary>
        /// 布尔型
        /// </summary>
        Boolean = 4,

        /// <summary>
        /// 定长字符型
        /// </summary>
        Char = 5,

        /// <summary>
        /// 日期时间
        /// </summary>
        DateTime = 6,

        /// <summary>
        /// 数值型 10 38 to -10 38,Sql Server为Numeric,Oracle为Number
        /// </summary>
        Decimal = 7,

        /// <summary>
        /// 单精度浮点数
        /// </summary>
        Float = 8,

        /// <summary>
        /// 双精度浮点数
        /// </summary>
        Double = 9,

        /// <summary>
        /// 非整型数字
        /// </summary>
        Currency = 10,

        /// <summary>
        /// 包含二进制数据的数据类型,SQL Server中为Image,vabinarymax,Oracle中为Bolb.
        /// </summary>
        Blob = 11,

        /// <summary>
        /// 大文本
        /// </summary>
        Text = 12,

        /// <summary>
        /// 时间戳类型
        /// </summary>
        TimeStamp = 13,

        /// <summary>
        /// 全局唯一标志型
        /// </summary>
        Guid = 14,

        /// <summary>
        /// 不定长二进制数据
        /// </summary>
        VarBinary = 15,

        /// <summary>
        /// 任意数据
        /// </summary>
        Variant = 16,

        /// <summary>
        /// 游标类型(支持ORACLE)
        /// </summary>
        Cursor = 27

    }
}
