﻿
namespace Wcdf.DataPortalClient
{
    /// <summary>
    /// 客户端数据请求代理类接口    
    /// </summary>
    /// <remarks>
    /// 客户端按分布式系统还分UI端及数据请求客户端.
    /// </remarks>
    public interface IDataPortalProxy : Server.IDataPortalServer
    {
        /// <summary>
        /// 是否为远程服务调用.如果为否则表示客户端与服务端都在同个程序域的单机环境中.        
        /// </summary>
        bool IsServerRemote { get; }

        void Invoke<TChannel>(System.Action<TChannel> action, string moduleName);

        TReturn Invoke<TChannel, TReturn>(System.Func<TChannel, TReturn> func, string moduleName);
    }
}
