﻿using System;
using Wcdf.Server;

namespace Wcdf.DataPortalClient
{
    /// <summary>
    /// 本地数据门户请求代理类.应用服务与客户端在同个进程和程序域中.    
    /// </summary>
    public class LocalProxy : IDataPortalProxy
    {
        private Server.IDataPortalServer _portal =
          new Server.DataPortal();


        /// <summary>
        /// 调用方法
        /// </summary>
        /// <typeparam name="TChannel">WCF形式声明的接口类型</typeparam>
        /// <param name="action">接口方法委托</param>
        /// <param name="moduleName">配置模块名</param>
        public void Invoke<TChannel>(Action<TChannel> action, string moduleName)
        {

        }
        /// <summary>
        /// 调用方法
        /// </summary>
        /// <typeparam name="TChannel">WCF形式声明的接口类型</typeparam>
        /// <typeparam name="TReturn">返回类型</typeparam>
        /// <param name="func">接口方法委托</param>
        /// <param name="moduleName">配置模块名</param>
        /// <returns>返回TReturn类型</returns>
        public TReturn Invoke<TChannel, TReturn>(Func<TChannel, TReturn> func, string moduleName)
        {
            TReturn result = default(TReturn);
            return result;
        }

        /// <summary>
        /// Called by <see cref="DataPortal" /> to create a
        /// new business object.
        /// </summary>
        /// <param name="objectType">Type of business object to create.</param>
        /// <param name="criteria">Criteria object describing business object.</param>
        /// <param name="context">
        /// <see cref="Server.DataPortalContext" /> object passed to the server.
        /// </param>
        public DataPortalResult Create(
          Type objectType, object criteria, DataPortalContext context)
        {
            return _portal.Create(objectType, criteria, context);
        }

        /// <summary>
        /// Called by <see cref="DataPortal" /> to load an
        /// existing business object.
        /// </summary>
        /// <param name="objectType">Type of business object to retrieve.</param>
        /// <param name="criteria">Criteria object describing business object.</param>
        /// <param name="context">
        /// <see cref="Server.DataPortalContext" /> object passed to the server.
        /// </param>
        public DataPortalResult Fetch(Type objectType, object criteria, DataPortalContext context)
        {
            return _portal.Fetch(objectType, criteria, context);
        }

        /// <summary>
        /// Called by <see cref="DataPortal" /> to update a
        /// business object.
        /// </summary>
        /// <param name="obj">The business object to update.</param>
        /// <param name="context">
        /// <see cref="Server.DataPortalContext" /> object passed to the server.
        /// </param>
        public DataPortalResult Update(object obj, DataPortalContext context)
        {
            return _portal.Update(obj, context);
        }

        /// <summary>
        /// Called by <see cref="DataPortal" /> to delete a
        /// business object.
        /// </summary>
        /// <param name="objectType">Type of business object to create.</param>
        /// <param name="criteria">Criteria object describing business object.</param>
        /// <param name="context">
        /// <see cref="Server.DataPortalContext" /> object passed to the server.
        /// </param>
        public DataPortalResult Delete(Type objectType, object criteria, DataPortalContext context)
        {
            return _portal.Delete(objectType, criteria, context);
        }

        /// <summary>
        /// 是否为向远程服务发请求.        
        /// </summary>
        public bool IsServerRemote
        {
            get { return false; }
        }

    }
}
