﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf
{
    /// <summary>
    /// 字段标记,表示该字段不参与撤消处理.    
    /// </summary>
    /// <remarks>
    /// Marking a variable with this attribute will cause the n-level
    /// undo process to ignore that variable's value. The value will
    /// not be included in a snapshot when BeginEdit is called, nor
    /// will it be restored when CancelEdit is called.
    /// </remarks>
    [AttributeUsage(AttributeTargets.Field)]
    public sealed class NotUndoableAttribute : Attribute
    {

    }
}
