﻿
using System;
namespace Wcdf
{
    /// <summary>
    /// 父对象与另一对象的关系枚举    
    /// </summary>
    [Flags]
    public enum RelationshipTypes
    {
        /// <summary>
        /// 默认值，表示属性未指定
        /// The default value, indicating all values are cleared
        /// </summary>
        None = 0x0,
        /// <summary>
        /// 表示属性为子对象       
        /// </summary>
        Child = 0x1,
        /// <summary>
        /// 表示属性指向延迟加载对象，在设置或加载对象前试图获取或者读取该对象值都将引发异常。        
        /// </summary>
        LazyLoad = 0x2,
        /// <summary>
        /// 属性值存储于私有字段中，在FieldManager对象中试图读取或写入将会引发异常。
        /// 非泛型ReadProperty/LoadProperty方法将调用属性的get/set方法。        
        /// </summary>
        PrivateField = 0x4,

        /// <summary>
        /// 表示该字段为数据库表主键
        /// </summary>
        PrimaryKey=0x8,
    }
}
