﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Rules
{
    /// <summary>
    /// 字段权限
    /// </summary>
    public class FieldRight : ICloneable
    {
        /// <summary>
        /// 字段名
        /// </summary>
        public string FieldName { get; set; }
        /// <summary>
        /// 是否只读
        /// </summary>
        public bool IsReadOnly { get; set; }
        /// <summary>
        /// 是否可为空
        /// </summary>
        public bool IsUnnullable { get; set; }
        /// <summary>
        /// 是否不可见
        /// </summary>
        public bool IsUnvisible { get; set; }
        /// <summary>
        /// 查询条件
        /// </summary>
        public string SelectCondition { get; set; }


        #region ICloneable 成员

        public object Clone()
        {
            FieldRight clone = new FieldRight();
            clone.FieldName = this.FieldName;
            clone.IsReadOnly = this.IsReadOnly;
            clone.IsUnnullable = this.IsUnnullable;
            clone.IsUnvisible = this.IsUnvisible;
            clone.SelectCondition = this.SelectCondition;
            return clone;
        }

        #endregion
    }
}
