﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Rules
{
    /// <summary>
    /// 定义权限规则    
    /// </summary>
    public interface IAuthorizationRule
    {
        /// <summary>
        /// 执行权限规则
        /// </summary>
        /// <param name="context">Rule context object.</param>
        void Execute(AuthorizationContext context);
        /// <summary>
        /// Gets the element (property/method)
        /// to which this rule is associated.
        /// </summary>
        Wcdf.Core.IMemberInfo Element { get; }
        /// <summary>
        /// Gets the authorization action this rule
        /// will enforce.
        /// </summary>
        AuthorizationActions Action { get; }
        /// <summary>
        /// Gets a value indicating whether the results
        /// of this rule can be cached at the business
        /// object level.
        /// </summary>
        bool CacheResult { get; }
       
    }
}
