﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wcdf.Rules
{
    /// <summary>
    /// 对象权限
    /// </summary>
    public class ObjectRight : ICloneable
    {
        /// <summary>
        /// 角色ID
        /// </summary>
        public string RoleID { get; set; }
        /// <summary>
        /// 对象名
        /// </summary>
        public string ObjectName { get; set; }
        /// <summary>
        /// 是否可读
        /// </summary>
        public bool IsCanSelect { get; set; }
        /// <summary>
        /// 是否可增
        /// </summary>
        public bool IsCanInsert { get; set; }
        /// <summary>
        /// 是否可更新
        /// </summary>
        public bool IsCanUpdate { get; set; }
        /// <summary>
        /// 是否可更新
        /// </summary>
        public bool IsCanDelete { get; set; }

        /// <summary>
        /// 是否控制
        /// </summary>
        public bool IsControl { get; set; }

        /// <summary>
        /// 字段列表
        /// </summary>
        public List<FieldRight> FieldRightList { get; set; }

        public ObjectRight()
        {
            IsControl = true;
            FieldRightList = new List<FieldRight>();
        }

        #region ICloneable 成员

        public object Clone()
        {
            ObjectRight or = new ObjectRight();
            or.RoleID = this.RoleID;
            or.ObjectName = this.ObjectName;
            or.IsCanSelect = this.IsCanSelect;
            or.IsCanInsert = this.IsCanInsert;
            or.IsCanDelete = this.IsCanDelete;
            or.IsCanUpdate = this.IsCanUpdate;
            or.IsControl = this.IsControl;
            //or.FieldRightList.AddRange(this.FieldRightList.CopyTo();
            foreach (var item in this.FieldRightList)
            {
                FieldRight fr = item.Clone() as FieldRight;
                or.FieldRightList.Add(fr);
            }
            return or;
        }

        #endregion
    }
}
