﻿using System;

namespace Wcdf.Serialization.Mobile
{
    /// <summary>
    /// 子对象为空时的占位符,该类方法并无具体实现
    /// </summary>
    [Serializable()]
    public sealed class NullPlaceholder : IMobileObject
    {
        #region Constructors

        /// <summary>
        /// Creates an instance of the type.
        /// </summary>
        public NullPlaceholder()
        {
            // Nothing
        }

        #endregion

        #region IMobileObject Members
        
        public void GetState(SerializationInfo info)
        {
            // Nothing
        }

        public void GetChildren(SerializationInfo info, MobileFormatter formatter)
        {
            // Nothing
        }

        public void SetState(SerializationInfo info)
        {
            // Nothing
        }

        public void SetChildren(SerializationInfo info, MobileFormatter formatter)
        {
            // Nothing
        }

        #endregion
    }
}
