﻿using System;
using System.Collections.Generic;

namespace Wcdf.Serialization.Mobile
{
    /// <summary>
    /// 继承<see cref="IMobileObject" />实现对象比较.
    /// </summary>
    /// <typeparam name="T">Type of objects to compare.</typeparam>
    public sealed class ReferenceComparer<T> : IEqualityComparer<T>
    {
        #region IEqualityComparer<T> Members

        /// <summary>
        /// 检查两对象是否相等
        /// </summary>
        /// <param name="x">First object.</param>
        /// <param name="y">Second object.</param>
        public bool Equals(T x, T y)
        {
            return Object.ReferenceEquals(x, y);
        }

        /// <summary>
        /// 取得对象hash值
        /// </summary>
        /// <param name="obj">引用的对象.</param>
        public int GetHashCode(T obj)
        {
            return obj.GetHashCode();
        }

        #endregion
    }
}
