﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf.Serialization.Mobile;

namespace Wcdf.Serialization
{
    /// <summary>
    /// Factory used to create the appropriate
    /// serialization formatter object based
    /// on the application configuration.
    /// </summary>
    public static class SerializationFormatterFactory
    {
        /// <summary>
        /// Creates a serialization formatter object.
        /// </summary>
        public static ISerializationFormatter GetFormatter()
        {
#if SILVERLIGHT
      return new Csla.Serialization.Mobile.MobileFormatter();
#else
            if (ApplicationContext.SerializationFormatter == ApplicationContext.SerializationFormatters.BinaryFormatter)
                return new BinaryFormatterWrapper();
            else
                return new NetDataContractSerializerWrapper();
#endif
        }
    }
}
