﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf.Core;

namespace Wcdf.Server
{
    /// <summary>
    /// 做为客户端和服务端数据交互的传输对象.    
    /// </summary>
    [Serializable()]
    public class DataPortalResult
    {
        private object _returnObject;
        private ContextDictionary _globalContext;

        /// <summary>
        /// 业务对象
        /// </summary>
        public object ReturnObject
        {
            get { return _returnObject; }
        }

        /// <summary>
        /// 服务端的全局对象        
        /// </summary>
        public ContextDictionary GlobalContext
        {
            get { return _globalContext; }
        }

        /// <summary>
        /// Creates an instance of the object.
        /// </summary>
        public DataPortalResult()
        {
            _globalContext = ApplicationContext.ContextManager.GetGlobalContext();
        }

        /// <summary>
        /// Creates an instance of the object.
        /// </summary>
        /// <param name="returnObject">Object to return as part
        /// of the result.</param>
        public DataPortalResult(object returnObject)
        {
            _returnObject = returnObject;
            _globalContext = ApplicationContext.ContextManager.GetGlobalContext();
        }

        /// <summary>
        /// Creates an instance of the object.
        /// </summary>
        /// <param name="returnObject">Object to return as part
        /// of the result.</param>
        /// <param name="globalContext">  Global context delivered via current reuest from the server
        /// </param>
        public DataPortalResult(object returnObject, ContextDictionary globalContext)
        {
            _returnObject = returnObject;
            _globalContext = globalContext;
        }
    }
}
