﻿using System.ServiceModel;
using Wcdf.Server.Hosts.WcfChannel;

namespace Wcdf.Server.Hosts
{
    /// <summary>
    /// WCF门户接口契约
    /// </summary>
    [ServiceContract]
    public interface IWcfPortal
    {
        /// <summary>
        /// Create a new business object.
        /// </summary>
        /// <param name="request">The request parameter object.</param>
        [OperationContract]
        [UseNetDataContract]
        WcfResponse Create(CriteriaRequest request);
        /// <summary>
        /// Get an existing business object.
        /// </summary>
        /// <param name="request">The request parameter object.</param>
        [OperationContract]
        [UseNetDataContract]
        WcfResponse Fetch(CriteriaRequest request);
        /// <summary>
        /// Update a business object.
        /// </summary>
        /// <param name="request">The request parameter object.</param>
        [OperationContract]
        [UseNetDataContract]
        WcfResponse Update(UpdateRequest request);
        /// <summary>
        /// Delete a business object.
        /// </summary>
        /// <param name="request">The request parameter object.</param>
        [OperationContract]
        [UseNetDataContract]
        WcfResponse Delete(CriteriaRequest request);
    }
}
