﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Configuration;
using System.ServiceModel.Description;

namespace Wcdf.Server.Hosts.WcfChannel
{
    /// <summary>
    /// 服务终结点行为
    /// </summary>
    public class ServiceEndpointBehavior :BehaviorExtensionElement, IEndpointBehavior
    {
        #region IEndpointBehavior 成员

        public void AddBindingParameters(ServiceEndpoint endpoint, System.ServiceModel.Channels.BindingParameterCollection bindingParameters)
        {

        }

        public void ApplyClientBehavior(ServiceEndpoint endpoint, System.ServiceModel.Dispatcher.ClientRuntime clientRuntime)
        {

        }

        public void ApplyDispatchBehavior(ServiceEndpoint endpoint, System.ServiceModel.Dispatcher.EndpointDispatcher endpointDispatcher)
        {
            endpointDispatcher.DispatchRuntime.MessageInspectors.Add(new ServiceDispatchMessageInspector());            
            //错误处理模块
            endpointDispatcher.ChannelDispatcher.ErrorHandlers.Add(new ServiceErrorHandler());            
        }

        public void Validate(ServiceEndpoint endpoint)
        {
        }

        #endregion

        #region override BehaviorExtensionElement method
        public override Type BehaviorType
        {
            get { return typeof(ServiceEndpointBehavior); }
        }

        protected override object CreateBehavior()
        {
            return new ServiceEndpointBehavior();
        }
        #endregion
    }
}
