﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Wcdf;
using System.ComponentModel.DataAnnotations;

namespace WpfLib
{
    public class OrgInfo : BusinessBase<OrgInfo>
    {

        public OrgInfo()
        {
        }

        public override string GetDataObjectName()
        {
            return "sys_user";
        }

        protected override void AddBusinessRules()
        {
            Wcdf.Rules.CommonRules.MaxLength leng = new Wcdf.Rules.CommonRules.MaxLength(OrgCDProperty, 10);
            BusinessRules.AddRule(leng);
            //base.BusinessRules.a
            base.AddBusinessRules();
        }

        public static readonly PropertyInfo<Guid> KeyIDProperty = RegisterProperty<Guid>(c => c.KeyID, "KeyID", RelationshipTypes.PrimaryKey);
        public Guid KeyID
        {
            get { return GetProperty(KeyIDProperty); }
            set { SetProperty(KeyIDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgCDProperty = RegisterProperty<string>(c => c.UserID, "UserID");
        [StringLength(10)]
        public string UserID
        {
            get { return GetProperty(OrgCDProperty); }
            set { SetProperty(OrgCDProperty, value); }
        }

        public static readonly PropertyInfo<string> OrgNameProperty = RegisterProperty<string>(c => c.UserName, "UserName");
        public string UserName
        {
            get { return GetProperty(OrgNameProperty); }
            set { SetProperty(OrgNameProperty, value); }
        }

        public static readonly PropertyInfo<string> TelProperty = RegisterProperty<string>(c => c.Tel, "Tel");
        public string Tel
        {
            get { return GetProperty(TelProperty); }
            set { SetProperty(TelProperty, value); }
        }

        public static readonly PropertyInfo<DateTime> SetUpDateProperty = RegisterProperty<DateTime>(c => c.SetUpDate, "SetUpDate");
        public DateTime SetUpDate
        {
            get { return GetProperty(SetUpDateProperty); }
            set { SetProperty(SetUpDateProperty, value); }
        }

    }
}
